{ =========================================================================== }
{                                 AJUSTES.PAS                                 }
{ =========================================================================== }

program Ajustes;

{  ---> ajusta ou modifica valores constantes usados por ALC                  }

{$E+,N+}

uses
  Crt, FPTCBas;

var
  arq: file of real;

{ --------------------------------------------------------------------------- }

procedure AjustaEquacao;

const
  erro1: real = 1E-10; erro2: real = 1E-10;
  erro3: real = 1E-10; erro4: real = 1E-06;
  erro5: real = 1E-16; erro6: real = 1E-10;

var
  i: byte;
  NErro1, NErro2, NErro3, NErro4, NErro5, NErro6: real;

begin
  Cls; Cor(5, 0);
  Writeln(#213, Repete(77, #205), #184);
  for i := 1 to 22 do
    Writeln(#179, Spc(77), #179);
  Write(#212, Repete(77, #205), #190);
  Window(2, 2, 78, 23); Cor(2, 7);  ClrScr;
  Writeln;
  Writeln('                  AJUSTANDO OS ERROS DA UNIDADE EQUACAO.TPU');
  Writeln;
  Writeln('  ', #16, ' A seguir serao apresentados ',
                                'os diversos erros usados na unidade EQUACAO');
  Writeln('  Para manter o valor padrao apresentado responda ',
                                                 ' como novo valor  do erro ');
  Writeln('  qualquer  valor menor ou igual  a zero. ',
                                          'Podem  entrar nmeros na forma de');
  Writeln('  potncias de 10 (Ex.: 1E-3 = 0.001, 2.79E-2 = 0.0279, etc.).');
  Window(2, 10, 78, 23); Cor(2, 0);
  Writeln('  1. Na resoluao de equaoes do 2o. grau, o ',
                                             'discriminante ser considerado');
  Writeln('     nulo sempre que seu mdulo for ',
                                    'menor ou igual a  ERRO1.  O valor atual');
  Writeln('     de ERRO1    1E-10, ou seja, 0.0000000001.');
  Writeln;
  Write('     FORNEA O NOVO VALOR DE ERRO1 ', #16, ' ');
  Readln(NErro1); if (NErro1 > 0) then erro1 := NErro1;
  Writeln;
  Writeln('                                         2');
  Writeln('  2. A divisao de um polinmio p(x) ',
                                    'por x  + px + q  ser considerada exata');
  Writeln('     se o resto da divisao for da ',
                                  'forma  ax + b  com os mdulos de  a  e  b');
  Writeln('     menores ou iguais a ERRO2 cujo valor atual    1E-10.');
  Writeln;
  Write('     FORNEA O NOVO VALOR DE ERRO2 ', #16, ' ');
  Readln(NErro2); if (NErro2 > 0) then erro2 := NErro2;
  Writeln; Writeln;
  Writeln('  3. A divisao de um polinmio p(x) por x - a ser ',
                                                   'considerada exata  se  o');
  Writeln('     mdulo do resto for menor ou igual a  ',
                                           'ERRO3. O valor atual de ERRO3  ');
  Writeln('     1E-10.');
  Writeln;
  Write('     FORNEA O NOVO VALOR DE ERRO3 ', #16, ' ');
  Readln(NErro3); if (NErro3 > 0) then erro3 := NErro3;
  Writeln; Writeln;
  Writeln('  4. Os   coeficientes   da   equacao   que    ',
                                               'estiverem     no   intervalo');
  Writeln('     [n - ERRO4, n + ERRO4] com n ',
                                  'inteiro serao arredondados para n.  O va-');
  Writeln('     lor atual de ERRO4    1E-06.');
  Writeln;
  Write('     FORNEA O NOVO VALOR DE ERRO4 ', #16, ' ');
  Readln(NErro4); if (NErro4 > 0) then erro4 := NErro4;
  Writeln; Writeln;
  Writeln('  5. Na aplicacao do Algoritmo de Bairstow  ',
                                            'sao usados dois erros  ERRO5  e');
  Writeln('     ERRO6 cujos valores atuais sao 1E-16 e 1E-10 respectivamente.');
  Writeln;
  Write('     FORNEA O NOVO VALOR DE ERRO5 ', #16, ' ');
  Readln(NErro5); if (NErro5 > 0) then erro5 := NErro5;
  Writeln;
  Write('     FORNEA O NOVO VALOR DE ERRO6 ', #16, ' ');
  Readln(NErro6); if (NErro6 > 0) then erro6 := NErro6;
  Writeln; Writeln; Cor(2, 7);
  Writeln('  ', #16, ' Salvando esses valores no arquivo EQUACAO.ERR...');
  Assign(arq, 'EQUACAO.ERR');
  Rewrite(arq);
  Write(arq, erro1, erro2, erro3, erro4, erro5, erro6);
  Close(arq); Delay(2000);
end;

{ --------------------------------------------------------------------------- }

procedure AjustaMatrizes;

const
  erro1: real = 1E-10; erro2: real = 1E-10;
  erro3: real = 1E-10; erro4: real = 1E-10;
  erro5: real = 1E-08;

var
  i: byte;
  NErro1, NErro2, NErro3, NErro4, NErro5: real;

begin
  Cls; Cor(5, 0);
  Writeln(#213, Repete(77, #205), #184);
  for i := 1 to 22 do
    Writeln(#179, Spc(77), #179);
  Write(#212, Repete(77, #205), #190);
  Window(2, 2, 78, 23); Cor(2, 7);  ClrScr;
  Writeln;
  Writeln('          AJUSTANDO OS ERROS ',
                                    'DAS UNIDADES MATRIZES.TPU E FPTCBAS.TPU');
  Writeln;
  Writeln('  ', #16, ' A seguir  serao  apresentados os ',
                                    'diversos  erros  usados  nas  unidades ');
  Writeln('  MATRIZES e FPTCBAS.');
  Writeln('    Para manter o valor padrao apresentado responda ',
                                                   'como novo valor do erro ');
  Writeln('  qualquer  valor menor ou igual  a zero. ',
                                          'Podem  entrar nmeros na forma de');
  Writeln('  potncias de 10 (Ex.: 2E-3 = 0.002, -1.59E-2 = -0.0159, etc.).');
  Window(2, 11, 78, 23); Cor(2, 0);
  Writeln('  1. No clculo da matriz inversa um elemento ser ',
                                                   'considerado  nulo sempre');
  Writeln('     que seu mdulo for menor ou igual a ERRO1. ',
                                                'O  valor atual  de  ERRO1 e');
  Writeln('     1E-10, ou seja, 0.0000000001.');
  Writeln;
  Write('     FORNEA O NOVO VALOR DE ERRO1 ', #16, ' ');
  Readln(NErro1); if (NErro1 > 0) then erro1 := NErro1;
  Writeln; Writeln;
  Writeln('  2. No clculo do determinante ser ',
                                     'considerado nulo todo elemento com m-');
  Writeln('     dulo for menor ou igual ',
                             'a ERRO2 cujo valor atual    1E-10.             ');
  Writeln;
  Write('     FORNEA O NOVO VALOR DE ERRO2 ', #16, ' ');
  Readln(NErro2); if (NErro2 > 0) then erro2 := NErro2;
  Writeln; Writeln;
  Writeln('  3. No clculo da nulidade ser considerado nula toda ',
                                                       'linha cuja  soma dos');
  Writeln('     mdulos dos elementos for menor  ou igual a ',
                                                 ' ERRO3. O valor  atual  de');
  Writeln('     ERRO3     1E-10.');
  Writeln;
  Write('     FORNEA O NOVO VALOR DE ERRO3 ', #16, ' ');
  Readln(NErro3); if (NErro3 > 0) then erro3 := NErro3;
  Writeln; Writeln;
  Writeln('  4. A funao RAC da unidade FPTCBAS usada para  ',
                                                 'escrever nmeros  reais no');
  Writeln('     formato racional usa um ERRO4 cujo valor atual    1E-10.');
  Writeln;
  Write('     FORNEA O NOVO VALOR DE ERRO4 ', #16, ' ');
  Readln(NErro4); if (NErro4 > 0) then erro4 := NErro4;
  Writeln; Writeln;
  Writeln('  5. A funao APROXIMA da unidade FPTCBAS usada para ',
                                                    'identificar  os nmeros');
  Writeln('     reais do intervalo [n - ERRO5, n + ERRO5] com ',
                                                  'o inteiro n usa  ERRO5. O');
  Writeln('     valor atual de ERRO5    1E-08.');
  Writeln;
  Write('     FORNEA O NOVO VALOR DE ERRO5 ', #16, ' ');
  Readln(NErro5); if (NErro5 > 0) then erro5 := NErro5;
  Writeln; Writeln; Cor(2, 7);
  Writeln('  ', #16, ' Salvando esses valores no arquivo MATRIZES.ERR...');
  Assign(arq, 'MATRIZES.ERR');
  Rewrite(arq);
  Write(arq, erro1, erro2, erro3, erro4, erro5);
  Close(arq); Delay(2000);
end;

{ --------------------------------------------------------------------------- }

procedure AjustaAlgLin;

const
  erro1: real = 1E-10;
  erro2: real = 1E-10;
  erro3: real = 1E-10;

var
  i: byte;
  NErro1, NErro2, NErro3: real;

begin
  Cls; Cor(5, 0);
  Writeln(#213, Repete(77, #205), #184);
  for i := 1 to 22 do
    Writeln(#179, Spc(77), #179);
  Write(#212, Repete(77, #205), #190);
  Window(2, 2, 78, 23); Cor(2, 7);  ClrScr;
  Writeln;
  Writeln('          AJUSTANDO OS ERROS DAS UNIDADES ALGLIN.TPU E JORDAN.TPU');
  Writeln;
  Writeln('  ', #16, ' A seguir  serao  apresentados ',
                                 'os diversos  erros  usados  nas  unidades ');
  Writeln('  ALGLIN e JORDAN.');
  Writeln('    Para manter o valor padrao apresentado responda ',
                                                   'como novo valor do erro ');
  Writeln('  qualquer  valor menor ou igual  a zero.',
                                         ' Podem  entrar nmeros na forma de');
  Writeln('  potncias de 10 (Ex.: 1.2E-3 = 0.0012, 5E-4 = 0.0005, etc.).');
  Window(2, 11, 78, 23); Cor(2, 0);
  Writeln('  1. No clculo da multiplicidade dos autovalores ',
                                                  'sao identificados  os au-');
  Writeln('     tovalores cujo mdulo da diferena seja menor ou ',
                                                      'igual a ERRO1. O  va-');
  Writeln('     lor atual de ERRO1    1E-08, ou seja, 0.00000001.');
  Writeln;
  Write('     FORNEA O NOVO VALOR DE ERRO1 ', #16, ' ');
  Readln(NErro1); if (NErro1 > 0) then erro1 := NErro1;
  Writeln; Writeln;
  Writeln('  2. No clculo do polinmio mnimo ser considerada ',
                                                     'nula toda matriz cujos');
  Writeln('     mdulos dos elementos for menor ou igual ',
                                              'a  ERRO2  cujo valor  atual e');
  Writeln('     1E-04.');
  Writeln;
  Write('     FORNEA O NOVO VALOR DE ERRO2 ', #16, ' ');
  Readln(NErro2); if (NErro2 > 0) then erro2 := NErro2;
  Writeln; Writeln;
  Writeln('  3. No clculo da base da forma de Jordan, a funao H que ',
                                                           'fornece a altura');
  Writeln('     de um vetor utiliza um ERRO3 cujo valor atual    1E-06.');
  Writeln;
  Write('     FORNEA O NOVO VALOR DE ERRO3 ', #16, ' ');
  Readln(NErro3); if (NErro3 > 0) then erro3 := NErro3;
  Writeln; Writeln; Cor(2, 7);
  Writeln('  ', #16, ' Salvando esses valores no arquivo ALGLIN.ERR...');
  Assign(arq, 'ALGLIN.ERR');
  Rewrite(arq);
  Write(arq, erro1, erro2, erro3);
  Close(arq); Delay(2000);
end;

{ --------------------------------------------------------------------------- }

procedure AjustaDecimais;

const
  decimais: byte = 4;
  HaCor: byte = 1;
  largura: byte =  80;
  MaxQ: byte = 200;

var
  arq: file of byte;
  i: byte;
  NDecimais, NCor, NLargura, NQ: byte;

begin
  Cls; Cor(5, 0);
  Writeln(#213, Repete(77, #205), #184);
  for i := 1 to 22 do
    Writeln(#179, Spc(77), #179);
  Write(#212, Repete(77, #205), #190);
  Window(2, 2, 78, 23); Cor(2, 7);  ClrScr;
  Writeln;
  Writeln('         AJUSTANDO A QUANTIDADE DE CASAS DECIMAIS, CORES E LARGURA');
  Writeln;
  Writeln('  ', #16, ' Para manter  qualquer um dos valores  ',
                                          'apresentados a seguir responda um');
  Writeln('    0 como resposta.');
  Window(2, 9, 78, 23); Cor(2, 0);
  Writeln('  1. A quantidade de casas decimais com a qual ',
                                               'sao apresentados os resulta-');
  Writeln('     dos    4.');
  Writeln;
  Write('     FORNEA A NOVA QUANTIDADE DE CASAS DECIMAIS (DE 2 A 6) ',
                                                                     #16, ' ');
  Readln(NDecimais);
  if ((NDecimais >= 2) and (NDecimais <= 6)) then decimais := NDecimais;
  Writeln; Writeln;
  Writeln('  2. As telas apresentadas sao coloridas. ',
                                          'Digite um 0 se quiser manter esse');
  Writeln('     padrao ou qualquer inteiro maior ',
                                      'que zero para altera-lo, ou seja, pa-');
  Writeln('     ra que as telas sejam apresentadas ',
                                                         'em preto e branco.');
  Writeln;
  Write('     SUA OPAO ', #16, ' ');
  Readln(NCor); if (NCor > 0) then HaCor := 0;
  Writeln; Writeln;
  Writeln('  3. Na impressao dos resultados  no papel',
                                          '  usado um  campo de  largura 80');
  Writeln('     colunas.');
  Writeln;
  Write('     FORNEA O NOVO VALOR DA LARGURA (DE 40 A 250) ', #16, ' ');
  Readln(NLargura);
  if ((NLargura >= 40) and (NLargura <= 250)) then largura := NLargura;
  Writeln; Writeln;
  Writeln('  4. A funao RAC da unidade FPTCBAS ',
                                     'escreve um  nmero real no formato ra-');
  Writeln('     cional p/q desde que p = 1 ou q = 1',
                                        ' ou q <= MaxQ onde MaxQ  uma cons-');
  Writeln('     tante cujo valor atual    200.');
  Writeln;
  Write('     FORNEA O NOVO VALOR DE MAXQ (DE 20 A 255) ', #16, ' ');
  Readln(NQ);
  if ((NQ >= 20) and (NQ <= 255)) then MaxQ :=  NQ;
  Writeln; Writeln; Cor(2, 7);
  Writeln('  ', #16, ' Salvando esses valores no arquivo ALC.DTA...');
  Assign(arq, 'ALC.DTA');
  Rewrite(arq);
  Write(arq, decimais, HaCor, largura, MaxQ);
  Close(arq); Delay(2000);
end;

{ --------------------------------------------------------------------------- }

procedure Menu;

var
  ch: char;
  xpos, ypos, i: byte;
  cod: integer;

const
  opcao: array[1..4] of string[80] =
         ('1. Ajustar constantes da unidade EQUACAO.TPU                  ',
          '2. Ajustar constantes das unidades MATRIZES.TPU ou FPTCBAS.TPU',
          '3. Ajustar constantes das unidades JORDAN.TPU ou ALGLIN.TPU   ',
          '4. Ajustar casas decimais, cores, largura, denominador maximo ');

  posicao: array[1..4] of byte = (10, 12, 14, 16);

  conj: set of char = ['1', '2', '3', '4'];

begin
  Cls; Cor(2, 0);
  GoToXY(5, 7); Write(#201, Repete(70, #205), #187);
  for i := 8 to 18 do
  begin
    GoToXY(5, i); Write(#186); GoToXY(76, i); Write(#186);
  end;
  GoToXY(5, 19); Write(#200, Repete(70, #205), #188);
  GoToXY(34, 7); Write(' A J U S T E S ');
  GoToXY(17, 19); Write(' Use ', #24, ' ', #25,
                                   ' e ENTER para escolher ou ESC para sair ');
  Window(6, 8, 75, 18); Cor(3, 0); ClrScr; Window(1, 1, 80, 25);
  GoToXY(10, posicao[1]); Write(opcao[1]);
  GoToXY(10, posicao[2]); Write(opcao[2]);
  GoToXY(10, posicao[3]); Write(opcao[3]);
  GoToXY(10, posicao[4]); Write(opcao[4]);
  i :=  1; xpos := 10; ypos := posicao[1];
  Cor(0, 7); GoToXY(xpos, ypos); Write(opcao[i]);
  repeat
    ch :=  ReadKey;
    if (ch = #0) then
    begin
      ch := ReadKey;
      case ch of
        SetaPCima: begin
                     GoToXY(xpos, ypos);
                     Cor(3, 0);
                     Write(opcao[i]);
                     if (i > 1) then Dec(i) else Write(#7);
                     Cor(0, 7);
                     GoToXY(10, posicao[i]);
                     xpos := WhereX; ypos := WhereY;
                     Write(opcao[i]);
                   end;
        SetaPBaixo: begin
                      GoToXY(xpos, ypos);
                      Cor(3, 0);
                      Write(opcao[i]);
                      if (i < 4) then Inc(i) else Write(#7);
                      Cor(0, 7);
                      GoToXY(10, posicao[i]);
                      xpos := WhereX; ypos := WhereY;
                      Write(opcao[i]);
                    end;
      end;
    end;
  until (ch = ESC) or (ch = ENTER) or (ch in conj);
  if (ch = ESC) then
  begin
    Cls;
    Exit;
  end;
  if (ch in conj) then Val(ch, i, cod);
  case i of
    1 : AjustaEquacao;
    2 : AjustaMatrizes;
    3 : AjustaAlgLin;
    4 : AjustaDecimais;
  end;
  Menu;
end;

{ --------------------------------------------------------------------------- }

begin
  Menu;
end.

{ =========================================================================== }

