{ =========================================================================== }
{                                 MATARQ.PAS                                  }
{ =========================================================================== }

program MatArq;

uses
  Crt, FPTCBas;

type
  ind = array[1..100] of string[14];

var
  a: ind;
  total, i: byte;
  arq: text;
  s: string[13];
  ArqMat: file of matriz;
  mat: matriz;
  m, n: string[2];

begin
  Assign(arq, 'INDICE');  { o arquivo INDICE e' criado atraves do comando do }
  {$I-}                   { MS-DOS                                           }
  Reset(arq);             {              A> DIR *.MAT > INDICE               }
  {$I+}
  if (IOResult <> 0) then
  begin
    Writeln('*** ERRO: Nao foi encontrado o arquivo INDICE ***');
    Halt;
  end;

  i := 1; total := 0; Writeln;
  repeat
    Readln(arq, s);
    if (Pos('MAT', s) > 0) then
    begin
      a[i] := Copy(s, 1, 8);
      Assign(ArqMat, a[i] + '.MAT');
      Writeln('Lendo a ordem da matriz ', a[i] + '.MAT');
      Reset(ArqMat);
      Read(ArqMat, mat);
      Str(mat.m:2, m);
      Str(mat.n:2, n);
      a[i] := a[i] + ' ' + m + 'x' + n;
      Close(ArqMat);
      Inc(i); Inc(total);
    end;
  until Eof(arq) or (i > 100);
  Close(arq);

  Assign(arq, 'MAT');
  Rewrite(arq);
  for i := 1 to total do Writeln(arq, a[i]);
  Close(arq);
end.

{ =========================================================================== }

