{ =========================================================================== }
{                                    SM.PAS                                   }
{ =========================================================================== }

{$E+,N+,B-,F+,S+,R+}

{ ---> Constroi uma matriz de blocos a partir de duas matrizes                }

uses
  Matrizes, FPTCBas;

var
  nome, opcao, mat1, mat2, mat3: string[20];
  m1, m2, m3: matriz;
  cod: integer;
  i, j, op: byte;
  erro: boolean;
  tela: TelaPtr;

const
  mens: array[1..11] of string[80] =
  ('          Ŀ',
   '                                                                      ',
   '             Forma de usar  SM matriz1 matriz2 matriz3               ',
   '                                                                      ',
   '             onde                                                     ',
   '                                                                      ',
   '                  matriz3 = matriz de blocos matriz1, matriz2         ',
   '                                                                      ',
   '             Exemplo  SM M1 M2 M3 1                                  ',
   '                                                                      ',
   '          ');

begin
  New(tela);
  if (ParamCount < 3) then
  begin
    Writeln(#7);
    for i := 1 to 11 do Writeln(mens[i]);
    Writeln;
    Halt;
  end;
  opcao := ParamStr(4);
  Val(opcao, op, cod);
  mat1 := ParamStr(1); mat2 := ParamStr(2); mat3 := ParamStr(3);
  Writeln; LeMatrizDisco(m1, mat1, erro);
  Writeln; LeMatrizDisco(m2, mat2, erro);
  if (m1.m <> m1.n) or (m2.m <> m2.n) then
  begin
    Writeln;
    Writeln(#7, '*** AS MATRIZES PRECISAM SER QUADRADAS ***');
    Halt;
  end
  else
    if (m1.m + m2.m > MaxM) then
    begin
      Writeln; Writeln;
      Writeln(#7,'*** A SOMA DAS ORDENS DAS MATRIZES ULTRAPASSA ',MaxM,' ***');
      Halt;
    end;
  m3.m := m1.m + m2.m; m3.n := m1.n + m2.n;
  for i := 1 to m3.m do
    for j := 1 to m3.n do
      if (i <= m1.m) and (j <= m1.n) then
        m3.a[i, j] := m1.a[i, j]
      else
        if (i > m1.m) and (j > m1.n) then
          m3.a[i, j] := m2.a[i - m1.m, j - m1.n]
        else
          m3.a[i, j] := 0;
   Writeln; SalvaMatriz(m3, op, mat3, tela);
   Dispose(tela);
end.

{ =========================================================================== }

